Name:           libgit2
Version:        0.27.8
Release:        7
Summary:        portable, pure C implementation of the Git core methods
License:        GPLv2 with exceptions
URL:            https://libgit2.org
Source0:        https://github.com/libgit2/libgit2/archive/v%{version}.tar.gz

Patch0001:      0001-tests-don-t-run-buf-oom-on-32-bit-systems.patch
Patch0002:      CVE-2020-12278.patch
Patch0003:      CVE-2020-12279.patch
Patch0004:      Remove-error-prone-redundant-test.patch
Patch0005:      CVE-2023-22742.patch

BuildRequires:  gcc cmake >= 2.8.11 ninja-build http-parser-devel libcurl-devel
BuildRequires:  libssh2-devel openssl-devel python3 zlib-devel
Provides:       bundled(libxdiff)

%description
libgit2 is a portable, pure C implementation of the Git core methods provided as
a re-entrant linkable library with a solid API, allowing you to write native speed
custom Git applications in any language which supports C bindings.

%package        devel
Summary:        Development files for libgit2
Requires:       %{name} = %{version}-%{release}

%description    devel
This package contains libraries and headers for developing applications that use libgit2.

%prep
%autosetup -n %{name}-%{version} -p1
rm -rfv examples/network/.gitignore deps
sed -i '/ADD_TEST(online/s/^/#/' tests/CMakeLists.txt

%build
%cmake . -B%{_target_platform} -GNinja -DCMAKE_BUILD_TYPE=RelWithDebInfo \
  -DSHA1_BACKEND=OpenSSL -DUSE_HTTPS=OpenSSL %{nil}
%ninja_build -C %{_target_platform}

%install
%ninja_install -C %{_target_platform}

%check
%ninja_test -C %{_target_platform}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%license COPYING
%{_libdir}/%{name}.so.*

%files devel
%doc AUTHORS docs examples README.md
%{_libdir}/%{name}.so
%{_libdir}/pkgconfig/%{name}.pc
%{_includedir}/git2*

%changelog
* Thu Dec 14 2023 wangkai <13474090681@163.com> - 0.27.8-7
- Fix CVE-2023-22742

* Tue May 24 2022 liyanan <liyanan32@h-partners.com> - 0.27.8-6
- Remove error-prone, redundant test

* Fri Jul 23 2021 guoxiaoqi<guoxiaoqi2@huawei.com> - 0.27.8-5
- fix CVE-2020-12278 and CVE-2020-12279

* Mon May 18 2020 zhouyihang<zhouyihang3@huawei.com> - 0.27.8-4
- Rebuild for libgit2

* Thu Jan 16 2020 yangjian<yangjian79@huawei.com> - 0.27.8-3
- Change the Source to valid address

* Tue Dec 31 2019 lingsheng <lingsheng@huawei.com> - 0.27.8-2
- Package init
